﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate;
using FluentNHibernate.Cfg;
using System.Reflection;
using System.IO;
using NHibernate.Tool.hbm2ddl;
using NHibernate.Cfg;

namespace ByteTruncationRepro
{
    static class Program
    {
        static void Main()
        {
            NHibernate.Cfg.Configuration cfg = new NHibernate.Cfg.Configuration().Configure("NHibernateConfiguration.xml");
            ISessionFactory sessionFactory = Fluently.Configure(cfg)
                .Mappings(m => m.FluentMappings.AddFromAssembly(Assembly.GetExecutingAssembly()))
                .BuildSessionFactory();

            FileStream fs = new FileStream("TestFile.xml", FileMode.Open, FileAccess.Read);
            byte[] byteContent = new byte[fs.Length];
            fs.Read(byteContent, 0, System.Convert.ToInt32(fs.Length));
            fs.Close();

            TestEntity testEntity = new TestEntity();
            testEntity.FileBLOB = byteContent;
            int id = -1;

            int byteLengthIn = testEntity.FileBLOB.Length;

            using (ISession session = sessionFactory.OpenSession())
            {
                session.Save(testEntity);
                session.Flush();
                id = testEntity.Id;
            }

            using (ISession session = sessionFactory.OpenSession())
            {
                testEntity = session.Get<TestEntity>(id);
            }

            if (testEntity.FileBLOB.Length == 8000)
            {
                Console.WriteLine("Byte length in {0}, Byte length out {1}. Data truncated.", byteLengthIn.ToString(), testEntity.FileBLOB.Length.ToString());
            }
            Console.ReadLine();

            
        }

    }
}
